import { ComponentChild } from 'preact';
import { BehaviorSubject, Observable, Subject, Subscription } from 'rxjs';
export interface ComponentFunctionApi<P> {
    props: BehaviorSubject<P>;
    updates: Subject<P>;
    subscribe: (obs: Observable<any>) => void;
}
export declare type ComponentFunction<P, S> = (api: ComponentFunctionApi<P>) => Observable<S>;
export declare type ComponentTemplate<S> = (state: S) => ComponentChild;
export declare const createComponent: <P, S>(componentFunction: ComponentFunction<P, S>, template: ComponentTemplate<S>) => {
    new (props: P, context: any): {
        createSubscription(): Subscription;
        render(): ComponentChild;
        propsStream: BehaviorSubject<P>;
        updates: Subject<P>;
        subscriptions: Subscription[];
        componentDidMount(): void;
        componentWillReceiveProps(props: P): void;
        shouldComponentUpdate(_: P, nextState: S): boolean;
        componentDidUpdate(): void;
        componentWillUnmount(): void;
        componentWillMount?(): void;
        getChildContext?(): object;
        componentWillUpdate?(nextProps: Readonly<P>, nextState: Readonly<S>, nextContext: any): void;
        getSnapshotBeforeUpdate?(oldProps: Readonly<P>, oldState: Readonly<S>): any;
        componentDidCatch?(error: any, errorInfo: any): void;
        state: Readonly<S>;
        props: Readonly<P & import("preact").Attributes & {
            children?: import("preact").ComponentChildren;
            ref?: import("preact").RefObject<any> | import("preact").RefCallback<any> | undefined;
        }>;
        context: any;
        base?: Element | Text | undefined;
        setState<K extends keyof S>(state: Partial<S> | ((prevState: Readonly<S>, props: Readonly<P>) => Partial<S> | Pick<S, K> | null) | Pick<S, K> | null, callback?: (() => void) | undefined): void;
        forceUpdate(callback?: (() => void) | undefined): void;
    };
    displayName?: string | undefined;
    defaultProps?: any;
    contextType?: import("preact").Context<any> | undefined;
    getDerivedStateFromProps?(props: object, state: object): object | null;
    getDerivedStateFromError?(error: any): object | null;
};
//# sourceMappingURL=component.d.ts.map